// Class automatically generated by Dev-C++ New Class wizard

#include "ihex.h" // class's header file

// class constructor
ihex::ihex()
{
	// insert your code here
}

// class destructor
ihex::~ihex()
{
	// insert your code here
}

uint8_t ihex::checksum( ihex::data data )
{
  uint8_t all = 0;
  
  all = data.size + data.type + data.addrLO() + data.addrHI();
  
  for ( uint8_t i = 0; i < data.size; i++ )
  {
    all += data.d[i];
  }
  
  return 0 - all;
}

std::string ihex::hex2str( ihex::data data )
{
  char buf[256];
  
  sprintf( buf, ":%02X%04X%02X", data.size, data.addr, data.type );
  
  for ( uint8_t i = 0; i < data.size; i++ )
  {
    sprintf( buf+strlen(buf), "%02X", data.d[i] );
  }
  
  sprintf( buf+strlen(buf), "%02X", checksum(data) );
  
  return buf;
}

bool ihex::check( std::string str )
{
  if ( str.substr(0,1) != ":" )
    return false;
  
  if ( strtoul( str.substr(1,2).c_str(), NULL, 16 )*2 + 9 > strlen(str.c_str()) )
    return false;
  
  ihex::data data = str2hex( str );
  
  if ( checksum(data) != strtoul( str.substr(data.size*2+9,2).c_str(), NULL, 16 ) )
    return false;
  
  return true;
}

ihex::data  ihex::str2hex( std::string str )
{
  ihex::data data;
  
  data.size = strtoul( str.substr(1,2).c_str(), NULL, 16 );
  data.addr = strtoul( str.substr(3,4).c_str(), NULL, 16 );
  data.type = strtoul( str.substr(7,2).c_str(), NULL, 16 );
  
  for ( uint8_t i = 0; i < data.size; i++ )
  {
    data.d[i] = strtoul( str.substr(9+i*2,2).c_str(), NULL, 16 );
  }
  
  return data;
}

