// Class automatically generated by Dev-C++ New Class wizard

#include "program.h" // class's header file
#include <stdio.h>

#include "parport.h"
#include "piccmd.h"
#include "ihex.h"
#include <list>
#include <windows.h>

#define BETWEEN(x,a,b) ( (x >= a) && (x <= b) )

void delay_ms( uint16_t ms )
{
  //system( "sleep 1s" );
  Sleep( ms );
}

bool readfile( const std::string &filename, std::string &content )
{
  FILE *f = fopen( filename.c_str(), "r" );
  if ( f == NULL )
    return false;
  
  char buffer[1024 * 64];
  uint16_t size = fread( buffer, 1, sizeof(buffer)-1, f );
  buffer[size] = 0;
  
  content = buffer;
  
  fclose( f );
  return true;
}

bool savefile( const std::string &filename, const std::string &content )
{
  FILE *f = fopen( filename.c_str(), "w" );
  if ( f == NULL )
    return false;

  fwrite( content.c_str(), 1, content.size(), f );  
  
  fclose( f );
  return true;
}

std::list<std::string> linecutter( std::string str )
{
  std::list<std::string> zeilen;

  uint16_t last = 0;
  for ( uint16_t i = 0; i < str.size(); i++ )
  {
    if ( str[i] == '\n' )
    {
      zeilen.push_back( str.substr( last, i-last ) );
      last = i+1;
    }
  }
  
  return zeilen;
}

std::string linemerger( std::list<std::string> strings )
{
  std::string ret;
  
  for ( std::list<std::string>::iterator i = strings.begin(); i != strings.end(); i++ )
  {
    ret += *i + "\r\n";
  }
  
  return ret;
}

bool stringlist2hexlist( std::list<std::string> input, std::list<ihex::data> &ret )
{
  ihex::data data;
  class ihex ihex;
  
  for ( std::list<std::string>::iterator i = input.begin(); i != input.end(); i++ )
  {
    if ( ihex.check( *i ) )
    {
      data = ihex.str2hex( *i );
      ret.push_back( data );
    }
    else
    {
      printf( "ERROR! >%s< not in ihex format!\n", i->c_str() );
      return false;
    }
  }
  
  return true;
}

void demux( uint16_t addr, uint16_t word, program::picmemory &mem )
{
  //printf( "demux [%04X] = %04X\n", addr, word );
  
  if ( addr <= 0x1FFF )
  {
    // program memory space
    mem.PM[addr] = word;
    mem.PMsize = addr+1;
    
    printf( "PM [%04X] = %04X\n", addr, word );
  }
  else if BETWEEN( addr, 0x2000, 0x2007 )
  {
    // config space
    mem.config[ addr - 0x2000 ] = word;
    
    printf( "config [%04X] = %04X\n", addr-0x2000, word );
  }
  else if BETWEEN( addr, 0x2100, 0x21FF )
  {
    // data memory space
    mem.DM[ addr - 0x2100 ] = word & 0xFF;
    mem.DMsize = addr-0x2100+1;
    
    printf( "DM [%04X] = %04X\n", addr-0x2100, word );
  }
  else
  {
    printf( "error: write to unimplemented memory space! [%04X]=%04X\n", addr, word );
  }
  
}

bool convert( std::list<ihex::data> data, program::picmemory &mem )
{
  for ( std::list<ihex::data>::iterator i = data.begin(); i != data.end(); i++ )
  {
    for ( uint8_t x = 0; x < i->size / 2; x++ )
    {
      if ( i->type == 0 )
        demux( i->addr/2 + x, i->d[x*2] | i->d[x*2+1] << 8, mem );
    }

    //system( "PAUSE" );
  }
  
  return true;
}

// class constructor
program::program()
{
	// insert your code here
	debug = 0;
	parportaddr = 0x378;
}

// class destructor
program::~program()
{
	// insert your code here
}

std::list<std::string> program::split( std::string str )
{
  std::list<std::string> ret;
  
  printf( "TODO: implementieren\n" );
  
  return ret;
}

bool program::readfile( std::string filename, picmemory &mem )
{
  std::list<std::string> zeilen;
  std::string file;
  std::list<ihex::data> data;
  
  if ( !::readfile( filename, file ) )
  {
    printf( "readfile failed! >%s<\n", filename.c_str() );  
    return false;
  }
    
  zeilen = linecutter( file );  
  
  if ( !stringlist2hexlist( zeilen, data ) )
    return false;
  
  if ( !convert( data, mem ) )
    return false;
  
  return true;
}

bool program::savefile( std::string filename, picmemory &mem )
{
  FILE *f = fopen( filename.c_str(), "w" );
  if ( f == NULL )
    return false;
  
  class ihex ihex;
  ihex::data data;
  
  uint16_t size = mem.PMsize;
  uint16_t addr = 0;
  
  while ( size )
  {
    if ( size > 8 )
    {
      data.size = 16;
      size -= 8;
    }
    else
    {
      data.size = size*2;
      size = 0;
    }
    
    for ( uint16_t i = 0; i < data.size/2; i++ )
    {
      data.d[i*2+1] = (mem.PM[addr + i] >> 8) & 0xFF;
      data.d[i*2  ] =  mem.PM[addr + i]       & 0xFF;
    }
    
    printf( "PM[%04X] = %s\n", addr, ihex.hex2str( data ).c_str() );
    
    std::string s = ihex.hex2str( data ) + "\n";
    fwrite( s.c_str(), 1, s.size(), f );
    
    addr += 8;
  }
  
  data.size = 0;
  data.type = 1;
  std::string s = ihex.hex2str( data ) + "\n";
  fwrite( s.c_str(), 1, s.size(), f );
  
  fclose( f );
  return true;
}


void program::setfilename( std::string fname )
{
  filename = fname;
}

void program::verbose( uint8_t level )
{
  verboselevel = level;
}

void program::erase()
{
  printf( " --- erase ---\n" );
  
  class parport parport; parport.setaddr( parportaddr );
  class piccmd piccmd( parport );
  if ( debug )
    piccmd.debugmode( debug );
  
  piccmd.statRESET();
  piccmd.statLVP();

  piccmd.loadconfig( 0 );
  piccmd.chiperase();
  delay_ms( 10 );

  piccmd.statRESET();
}

void program::write()
{
  printf( " --- write %s ---\n", filename.c_str() );
  
  class parport parport; parport.setaddr( parportaddr );
  class piccmd piccmd( parport );
  if ( debug )
    piccmd.debugmode( debug );
  
  program::picmemory mem;
  bool ret = readfile( filename, mem );
  
  if ( ret )
    printf( "read okay %s\n", filename.c_str() );
  else
  {
    printf( "read error! %s\n", filename.c_str() );
    system("PAUSE");
    return;
  }
  
  piccmd.statRESET();

  // --- chiperase ------------------------------
  piccmd.statLVP();
  piccmd.loadconfig( 0 );
  piccmd.chiperase(); delay_ms( 8 );
  piccmd.statRESET();

  // --- program memory space -------------------
  piccmd.statLVP();
  for ( uint16_t y = 0; y < (mem.PMsize+3)>>2; y++ )
  {
    for ( uint8_t x = 0; x < 3; x++ )
    {
      printf( "schreibe PM[%04X] = %04X\n", y*4+x, mem.PM[y*4+x] );
      piccmd.loaddataPM( mem.PM[y*4+x] );
      piccmd.incaddr();
    }
    printf( "schreibe PM[%04X] = %04X\n", y*4+3, mem.PM[y*4+3] );
    piccmd.loaddataPM( mem.PM[y*4+3] );
    
    piccmd.beginprogonly();
    delay_ms( 2 );
    piccmd.endprogramming();
    
    piccmd.incaddr();
  }
  piccmd.statRESET();
  
  // --- config & id    space -------------------
  piccmd.statLVP();
  
  piccmd.loadconfig( 0 );
  
  printf( "schreibe config[0] = %04X \n", mem.config[0] );
  printf( "schreibe config[1] = %04X \n", mem.config[1] );
  printf( "schreibe config[2] = %04X \n", mem.config[2] );
  printf( "schreibe config[3] = %04X \n", mem.config[3] );
  printf( "schreibe config[7] = %04X \n", mem.config[7] );
  
  piccmd.loaddataPM( mem.config[0] ); piccmd.incaddr();
  piccmd.loaddataPM( mem.config[1] ); piccmd.incaddr();
  piccmd.loaddataPM( mem.config[2] ); piccmd.incaddr();
  piccmd.loaddataPM( mem.config[3] ); piccmd.beginprogonly(); delay_ms( 2 ); piccmd.endprogramming();
  piccmd.incaddr();
  
/*piccmd.loaddataPM( mem.config[4] ); piccmd.beginprogonly(); delay_ms( 1 ); piccmd.endprogramming(); /**/ piccmd.incaddr();
/*piccmd.loaddataPM( mem.config[5] ); piccmd.beginprogonly(); delay_ms( 1 ); piccmd.endprogramming(); /**/ piccmd.incaddr();
/*piccmd.loaddataPM( mem.config[6] ); piccmd.beginprogonly(); delay_ms( 1 ); piccmd.endprogramming(); /**/ piccmd.incaddr();
  piccmd.loaddataPM( mem.config[7] ); piccmd.beginprogonly(); delay_ms( 2 ); piccmd.endprogramming(); /**/ piccmd.incaddr();
  
  piccmd.statRESET();
  
  // --- data memory    space -------------------
  piccmd.statLVP();
  for ( uint16_t y = 0; y < mem.DMsize; y++ )
  {
    printf( "schreibe DM[%04X] = %04X\n", y, mem.DM[y] );
    piccmd.loaddataDM( mem.DM[y] );
    
    piccmd.beginprogonly();
    delay_ms( 2 );
    piccmd.endprogramming();
    
    piccmd.incaddr();
  }
  piccmd.statRESET();
  
  
}

void program::verify()
{
  printf( " --- verify %s ---\n", filename.c_str() );
}

void program::read()
{
  printf( " --- read %s ---\n", filename.c_str() );
  
  class parport parport; parport.setaddr( parportaddr );
  class piccmd piccmd( parport );
  if ( debug )
    piccmd.debugmode( debug );
  
  piccmd.statRESET();
  
  //uint16_t pmem[8];
  
  program::picmemory mem;
  mem.PMsize = 2048;
  
  piccmd.statLVP();
  for ( uint16_t y = 0; y < mem.PMsize; y++ )
  {
    mem.PM[ y ] = piccmd.readdataPM();
    piccmd.incaddr();
  }
  piccmd.statRESET();
  
  piccmd.statLVP();
  mem.DMsize = 256;
  for ( uint16_t y = 0; y < mem.DMsize; y++ )
  {
    mem.DM[ y ] = piccmd.readdataDM();
    piccmd.incaddr();
  }
  piccmd.statRESET();
  
  piccmd.statLVP();
  piccmd.loadconfig( 0 );
  for ( uint16_t y = 0; y < 8; y++ )
  {
    mem.config[ y ] = piccmd.readdataPM();
    piccmd.incaddr();
  }
  piccmd.statRESET();
  
  
  if ( verboselevel > 1 )
  {
    printf( "Program Memory:\n" );
    for ( uint16_t y = 0; y < 2048 / 8; y++ )
    {
      if ( (
        mem.PM[y*8+0] & 
        mem.PM[y*8+1] & 
        mem.PM[y*8+2] & 
        mem.PM[y*8+3] & 
        mem.PM[y*8+4] & 
        mem.PM[y*8+5] & 
        mem.PM[y*8+6] & 
        mem.PM[y*8+7]) != 0x3FFF )
        
      printf( "%04X: %04X %04X %04X %04X %04X %04X %04X %04X \n", y*8,
        mem.PM[y*8+0],
        mem.PM[y*8+1],
        mem.PM[y*8+2],
        mem.PM[y*8+3],
        mem.PM[y*8+4],
        mem.PM[y*8+5],
        mem.PM[y*8+6],
        mem.PM[y*8+7] );
    }

    printf( "Data Memory:\n" );
    for ( uint16_t y = 0; y < 256 / 8; y++ )
    {
      if ( (
        mem.DM[y*8+0] & 
        mem.DM[y*8+1] & 
        mem.DM[y*8+2] & 
        mem.DM[y*8+3] & 
        mem.DM[y*8+4] & 
        mem.DM[y*8+5] & 
        mem.DM[y*8+6] & 
        mem.DM[y*8+7]) != 0xFF )
        
      printf( "%04X: %02X %02X %02X %02X %02X %02X %02X %02X \n", y*8,
        mem.DM[y*8+0],
        mem.DM[y*8+1],
        mem.DM[y*8+2],
        mem.DM[y*8+3],
        mem.DM[y*8+4],
        mem.DM[y*8+5],
        mem.DM[y*8+6],
        mem.DM[y*8+7] );
    }

    printf( "Config Memory:\n" );
    for ( uint16_t y = 0; y < 8 / 8; y++ )
    {
      printf( "%04X: %04X %04X %04X %04X %04X %04X %04X %04X \n", y*8,
        mem.config[y*8+0],
        mem.config[y*8+1],
        mem.config[y*8+2],
        mem.config[y*8+3],
        mem.config[y*8+4],
        mem.config[y*8+5],
        mem.config[y*8+6],
        mem.config[y*8+7] );
    }
  }
  
  uint16_t size = 0;
  for ( uint16_t i = 0; i < mem.PMsize; i++ )
  {
      if ( mem.PM[i] != 0x3FFF )
         size = i+1;
  }
  mem.PMsize = size;
  
  if ( filename != "" )
  {
    bool ret = savefile( filename, mem );
    
    if ( verboselevel > 0 )
    {
      if ( ret )
        printf( "buffer written to file %s\n", filename.c_str() );
      else
        printf( "writeerror (%s)\n", filename.c_str() );
    }
  }
}

void program::stop()
{
  printf( " --- set MCLR# to 0 ---\n" );

  class parport parport; parport.setaddr( parportaddr );
  class piccmd piccmd( parport );
  if ( debug )
    piccmd.debugmode( debug );
  
  piccmd.statRESET();
}

void program::go()
{
  printf( " --- set MCLR# to 1 ---\n" );

  class parport parport; parport.setaddr( parportaddr );
  class piccmd piccmd( parport );
  if ( debug )
    piccmd.debugmode( debug );
  
  piccmd.statRUN();
}

void program::debugmode( uint8_t debuglevel )
{
  printf( " --- enable debugmode ---\n" );
  debug = debuglevel;
  printf( "\tdebuglevel = %x\n", debug );
}
